function chart(reporting) {
    "use strict";

    var model = openerp;

    reporting.ReportSaleChartWidget = reporting.Base.extend({

        BuildLineChart: function (label,data,CurrencyBase) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
                ticks: {
                    callback: function(tick) {
                        return tick.toLocaleString('de-DE');
                    }
                }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };
            var chart = new Chart($(".reporting-chart"), {
                type: 'line',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: data,
                            backgroundColor: '#bbdefb',
                            borderColor: '#0288d1',
                            borderWidth: 1,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    events: ['click'],
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.yLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    }
                }
            });
        },

        BuildBarChart: function (data,CurrencyBase,label,body) {
            var self = this;
            Chart.scaleService.updateScaleDefaults('linear', {
              ticks: {
                callback: function(tick) {
                    return tick.toLocaleString('de-DE');
                }
              }
            });
            Chart.defaults.global.tooltips.callbacks.label = function(tooltipItem, data) {
                var dataset = data.datasets[tooltipItem.datasetIndex];
                var datasetLabel = dataset.label || '';
                return datasetLabel +  dataset.data[tooltipItem.index].toLocaleString('de-DE');
            };

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');

            var chart = new Chart($(".reporting-chart"), {
                type: 'horizontalBar',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },
                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    title: {
                        display: false,
                    },
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                       display: false,
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.datasets[tooltipItem.datasetIndex].label || '';

                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(tooltipItem.xLabel, CurrencyBase.symbol, CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },

        BuildPieChart: function (data,CurrencyBase,label,body) {
            var self = this;

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');
            color.push('#f3e5f5');

            var chart = new Chart($(".reporting-pie-chart"), {
                type: 'pie',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },

                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                        position: 'right',
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.labels[tooltipItem.index] || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(data.datasets[0].data[tooltipItem.index],{
                                    symbol: "%",
                                    format: "%v%s",
                                    precision: 2,
                                    thousand: ".",
                                    decimal: ","
                                });
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },

        BuildDoughnutChart: function (data,CurrencyBase,label,body) {
            var self = this;

            var color = [];
            color.push('#BCCEF4');
            color.push('#A9E5E3');
            color.push('#A0D995');
            color.push('#C5D084');
            color.push('#FAE187');
            color.push('#FFBD82');
            color.push('#FFA8B8');
            color.push('#E5BEDD');
            color.push('#C4ABFE');
            color.push('#D8D8D8');

            var chart = new Chart($(".reporting-doughnut-chart"), {
                type: 'doughnut',
                data: {
                    labels: label,
                    datasets: [
                        {
                            label: false,
                            data: body,
                            backgroundColor: color,
                            fill: true,
                        }
                    ]
                },

                options: {
                    responsive: true,
                    responsiveAnimationDuration:10,
                    maintainAspectRatio:false,
                    hover: {
                        mode: 'nearest',
                        intersect: true
                    },
                    legend: {
                        position: 'left',
                    },
                    layout: {
                        padding: {
                            top: 0,
                            bottom: 0,
                            left : 0,
                            rigth: 0,
                        }
                    },
                    tooltips: {
                        callbacks: {
                            label: function(tooltipItem, data) {
                                var label = data.labels[tooltipItem.index] || '';
                                if (label) {
                                    label += ': ';
                                }
                                label += accounting.formatMoney(data.datasets[0].data[tooltipItem.index],{
                                    symbol: "%",
                                    format: "%v%s",
                                    precision: 2,
                                    thousand: ".",
                                    decimal: ","
                                });
                                return label;
                            }
                        }
                    },
                    events: ['click'],
                }
            });
        },
    });
}
