function report_product_list(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportProductListWidget = reporting.Base.extend({
        template: 'ReportProductList',
        rowsData :[],
        content :[],
        modules: ['product_brand'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-attribute' : 'updateAttributeSelections',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIntialSQL().then(function (IntialSQL) {
                return IntialSQL;
            }).then(function(IntialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = IntialSQL.companies;
                self.CompanyLogo = IntialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = IntialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                    PRODUCT CATEGORY
                =================================
                */
                self.ProductCategory = IntialSQL.categories;
                if(self.ProductCategory.length > 1){
                    self.$el.find('#current-category').append('<option value="9999999">Todas las Categorias</option>');
                    _.each(self.ProductCategory,function(item){
                        self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }
                /*
                =================================
                    PRODUCT BRAND
                =================================
                */
                self.ProductBrand = IntialSQL.brands;
                if(self.ProductBrand.length > 1){
                    self.$el.find('#current-brand').append('<option value="9999999">Todas las Marcas</option>');
                    _.each(self.ProductBrand,function(item){
                        self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.brand').css('display','none');
                }
                /*
                =================================
                    PRODUCT ATRIBUTTE
                =================================
                */
                self.ProductAttribute = IntialSQL.attributes;
                if(self.ProductAttribute.length > 1){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                    _.each(self.ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                /*
                =================================
                    PRODUCT ATRIBUTTE VALUE
                =================================
                */
                self.ProductAttributeValue = IntialSQL.attribute_values;
                if(self.ProductAttributeValue.length > 1){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                    _.each(self.ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
                return self.fetchProductPriceList();
            }).then(function(ProductPriceList){
                self.ProductPriceList = ProductPriceList;
                if(ProductPriceList.length > 0){
                    var sale = _.filter(ProductPriceList,function (item) {
                        return item.type == 'sale';
                    });
                    self.$el.find('#current-sale-price').append('<option value="9999999">Precio Base</option>');
                    _.each(sale,function(item){
                        self.$el.find('#current-sale-price').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.salePrice').css('display','none');
                }
                return self.fetchPricelistVersion();
            }).then(function(PricelistVersion){
                self.PricelistVersion = PricelistVersion;
                return self.fetchPricelistVersionItem();
            }).then(function(PricelistVersionItem){
                self.PricelistVersionItem = PricelistVersionItem;
                return self.fetchIrModuleModule();
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.ProductProduct = DataSQL.products;
                self.ResCurrency = DataSQL.currencies;
                return self.BuildTable();
            });
        },

        fetchIntialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-product-list');
            return data;
        },

        fetchIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            PRICE LIST
        =====================================================================*/
        fetchProductPriceList: function() {
            var self = this;
            var domain = [];
            var ProductProduct = new model.web.Model('product.pricelist');
            return ProductProduct.call('getProductPriceList',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            PRICE LIST VERSION
        =====================================================================*/
        fetchPricelistVersion: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','listprice_id','items_id','date_start','date_end'];
            var domain = [['active','=',true]];
            var ResUser = new model.web.Model('product.pricelist.version');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            PRICE LIST VERSION ITEMS
        =====================================================================*/
        fetchPricelistVersionItem: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = [
                'name',
                'product_id',
                'categ_id',
                'min_quantity',
                'product_tmpl_id',
                'sequence',
                'base',
                'price_discount',
                'price_surcharge',
                'price_round',
                'price_min_margin',
                'price_max_margin'
            ];
            var ResUser = new model.web.Model('product.pricelist.item');
            ResUser.query(fields).filter().all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateAttributeSelections: function () {
            var self = this;
            var attribute_value;
            var attribute = self.$el.find('#current-attribute').val();
            if(attribute != 9999999){
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    if(parseFloat(attribute) == item.attribute_id){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getProductProduct: function() {
            var self = this;
            var content = self.ProductProduct;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();

            content = _.flatten(_.filter(content,function (item) {
                return item.active == true && item.sale_ok == true;
            }));

            var store_ids = _.flatten(_.map(self.ResStore, function (item) {
                return item.id;
            }));

            var company_ids = _.flatten(_.map(self.ResCompany, function (item) {
                return item.id;
            }));

            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == parseInt(company) || item.company_id == null;
                }));
            }else{
                content = _.flatten(_.filter(content,function (item) {
                    return _.contains(company_ids, item.company_id) || item.company_id == null;
                }));
            }

            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == parseInt(store) || item.store_id == null;
                }));
            }else{
                content = _.flatten(_.filter(content,function (item) {
                    return _.contains(store_ids, item.store_id) || item.store_id == null;
                }));
            }

            if(type && type != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.type == parseInt(type);
                }));
            }

            if(category && category != 9999999){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                content = _.flatten(_.filter(content,function (item) {
                    return _.contains(categ_ids, item.categ_id);
                }));
            }
            if(brand && brand != 9999999){
                content = _.filter(content,function (item) {
                    return item.product_brand_id == parseInt(brand);
                });
            }
            if(attribute && attribute != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_ids, parseInt(attribute));
                });
            }
            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_value_ids, parseInt(attribute_value));
                });
            }
            return content;
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            });
        },

        getPricelistVersion: function(id){
            var self = this;
            return _.filter(self.PricelistVersion,function (item) {
                return item.id === id;
            });
        },

        getPricelistVersionItem: function(id){
            var self = this;
            var item= _.filter(self.PricelistVersionItem,function (item) {
                return item.id === id;
            });
            return item[0];
        },

        getProductSalePrice: function(product){
            var self = this;
            var r;
            var CurrencyBase = self.ResCompany[0].currency_id;
            var today = moment().format('YYYY-MM-DD');
            var salePrice = self.$el.find('#current-sale-price').val();
            var company = self.$el.find('#current-company').val();

            if(salePrice && salePrice != 9999999){
                var priceList= _.filter(self.ProductPriceList,function (item) {
                    return item.id == salePrice;
                });

                var x = _.map(priceList, function(map){
                    if(map.version_id.length > 0){
                        _.each(map.version_id, function(v){
                            var version = self.getPricelistVersion(v);
                            var date_start = version.date_start;
                            var date_end = version.date_end;
                            r= _.filter(version, function(a){
                                return ((a.date_start == false) || (a.date_start <= today)) && ((a.date_end == false) || (a.date_end >= today));
                            });
                        });

                        var item =  _.map(r[0].items_id,function(i){
                            return self.getPricelistVersionItem(i);
                        });

                        var items =[];
                        var items2 = [];
                        _.each(item, function(index){
                            if(index.product_tmpl_id && index.product_tmpl_id[0] == product.product_tmpl_id){
                                items.push(index);
                            }
                            if(index.sequence > 1) {
                                items2.push(index);
                            }
                        });

                        if(items.length > 0){
                            return items[0];
                        }else{
                            if(items2.length > 0){
                                items2.sort(function(a, b) {
                                    return a.sequence - b.sequence;
                                });
                                return items2[0];
                            }
                        }
                    }
                });

                if(CurrencyBase.id == priceList[0].currency_id.id){
                    return product.list_price*(1+x[0].price_discount)+x[0].price_surcharge;
                }else{
                    var price = 0;
                    if(CurrencyBase.rate_silent > priceList[0].currency_id.rate_silent){
                        if(x[0].base == 1){
                            price = (product.list_price / (CurrencyBase.rate_silent / priceList[0].currency_id.rate_silent))*(1+x[0].price_discount)+x[0].price_surcharge;
                        }else{
                            price = (product.standard_price / (CurrencyBase.rate_silent / priceList[0].currency_id.rate_silent))*(1+x[0].price_discount)+x[0].price_surcharge;
                        }
                    }else{
                        if(x[0].base == 1){
                            price = (product.list_price * (priceList[0].currency_id.rate_silent / CurrencyBase.rate_silent))*(1+x[0].price_discount)+x[0].price_surcharge;
                        }else{
                            price = (product.standard_price * (priceList[0].currency_id.rate_silent / CurrencyBase.rate_silent))*(1+x[0].price_discount)+x[0].price_surcharge;
                        }
                    }
                    return price;
                }
            }else{
                return product.list_price;
            }
        },

        getProductCategory: function (id) {
            var self = this;
            var category;
            category =  _.filter(self.ProductCategory,function (item) {
                return item.id == id;
            });
            if(category.length > 0)
                return category[0].name;
        },

        getProductPriceListCurrency: function (id) {
            var self = this;
            var pricelist;
            pricelist =  _.filter(self.ProductPriceList,function (item) {
                return item.id == id;
            });
            return _.filter(self.ResCurrency,function (item) {
                return item.id == pricelist[0].currency_id.id;
            });
        },

        BuildTable: function(){
            var self = this;
            console.log(self);
            var data = [];
            var pricelist = $('#current-sale-price').val();
            var purchasePrice = self.$el.find('#current-purchase-price').val();
            var salePrice = self.$el.find('#current-sale-price').val();
            var CurrencyBase = self.ResCompany[0].currency_id;
            if(pricelist && pricelist != 9999999){
                CurrencyBase = self.getProductPriceListCurrency(pricelist).shift();
            }
            var ProductProduct = self.getProductProduct();
            _.each(ProductProduct, function(item){
                var category = self.getProductCategory(item.categ_id);
                var SalePrice = self.getProductSalePrice(item);
                data.push({
                    id:item.id,
                    default_code : self.valorNull(item.default_code),
                    ean13 : self.valorNull(item.ean13),
                    name:item.product_name,
                    brand_name:item.brand_name,
                    category_name:category,
                    lst_price : accounting.formatMoney(SalePrice, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*
                    =============================
                        NO FORMAT
                    =============================
                    */
                    lst_price_no_formart : SalePrice
                });
            });

            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.CompanyLogo,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = ResCompany[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.ResCompany[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }
            var getColumns = [];
            var rows = [];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                var pdf_title = 'Catálogo de Productos.';
                var pdf_type = 'l';
                var pdf_name = 'catálogo_de_productos_';
                var pdf_columnStyles = {
                    default_code :{halign:'left'},
                    name :{halign:'left'},
                    brand_name :{halign:'left'},
                    category_name :{halign:'left'},
                    lst_price :{columnWidth:30, halign:'right'},
                };

                var filter = self.getFilter();
                var pdf = new reporting.ReportSalePdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },

        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var salePrice = self.$el.find('#current-sale-price').val();
            var brand = self.$el.find('#current-brand').val();
            var category = self.$el.find('#current-category').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var filter = [];

            if(company && company != 9999999){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }

            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                    return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value:  ResStore[0].name,
                });
            }

            if(type && type != 9999999){
                filter.push({
                    title: 'Tipo',
                    value:  $("#current-type option:selected").text(),
                });
            }

            if(salePrice && salePrice != 9999999){
                var sale =  _.filter(self.ProductPriceList,function (item) {
                    return item.id == salePrice;
                });
                filter.push({
                    title: 'Precio de Venta',
                    value: sale[0].name,
                });
                filter.push({
                    title: 'Moneda',
                    value: sale[0].currency_id.local_name,
                });
            }

            if(brand && brand != 9999999){
                brand =  _.filter(self.ProductBrand,function (item) {
                    return item.id == brand;
                });
                filter.push({
                    title: 'Marca',
                    value: brand[0].name,
                });
            }

            if(category && category != 9999999){
                category =  _.filter(self.ProductCategory,function (item) {
                    return item.id == category;
                });
                filter.push({
                    title: 'Categoría',
                    value: categ[0].name,
                });
            }

            if(attribute && attribute != 9999999){
                var attr =  _.filter(self.ProductAttribute,function (item) {
                    return item.id == attribute;
                });
                filter.push({
                    title: 'Atributo',
                    value: attr[0].name,
                });
            }

            if(attribute_value && attribute_value != 9999999){
                var attr_value =  _.filter(self.ProductAttributeValue,function (item) {
                    return item.id == attribute_value;
                });
                filter.push({
                    title: 'Valor de Atributo',
                    value: attr_value[0].name,
                });
            }
            return filter;
        }
    });
}
